package edu.toronto.cs.se.modelepedia.tso.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import edu.toronto.cs.se.modelepedia.tso.Read;
import edu.toronto.cs.se.modelepedia.tso.Synch;
import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;
import edu.toronto.cs.se.modelepedia.tso.Write;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.TSOBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class SynchReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public SynchReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof Synch) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof Write && newEnd instanceof Write)) {
			return false;
		}
		Read target = getLink().getTgt();
		if (!(getLink().eContainer() instanceof TSOReadWriteSynch)) {
			return false;
		}
		TSOReadWriteSynch container = (TSOReadWriteSynch) getLink()
				.eContainer();
		return TSOBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistSynch_4002(container, getLink(), getNewSource(),
						target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof Read && newEnd instanceof Read)) {
			return false;
		}
		Write source = getLink().getSrc();
		if (!(getLink().eContainer() instanceof TSOReadWriteSynch)) {
			return false;
		}
		TSOReadWriteSynch container = (TSOReadWriteSynch) getLink()
				.eContainer();
		return TSOBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistSynch_4002(container, getLink(), source,
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setSrc(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTgt(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected Synch getLink() {
		return (Synch) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected Write getOldSource() {
		return (Write) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Write getNewSource() {
		return (Write) newEnd;
	}

	/**
	 * @generated
	 */
	protected Read getOldTarget() {
		return (Read) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Read getNewTarget() {
		return (Read) newEnd;
	}
}
