package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.BarrierItemSemanticEditPolicy;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class BarrierEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2003;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public BarrierEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new BarrierItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new BarrierFigure();
	}

	/**
	 * @generated
	 */
	public BarrierFigure getPrimaryShape() {
		return (BarrierFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof BarrierIdEditPart) {
			((BarrierIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getBarrierFigureLabelId());
			return true;
		}
		if (childEditPart instanceof BarrierUidEditPart) {
			((BarrierUidEditPart) childEditPart).setLabel(getPrimaryShape()
					.getBarrierFigureLabelUid());
			return true;
		}
		if (childEditPart instanceof BarrierIsStartEditPart) {
			((BarrierIsStartEditPart) childEditPart).setLabel(getPrimaryShape()
					.getBarrierFigureLabelIsStart());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof BarrierIdEditPart) {
			return true;
		}
		if (childEditPart instanceof BarrierUidEditPart) {
			return true;
		}
		if (childEditPart instanceof BarrierIsStartEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(TSOVisualIDRegistry
				.getType(BarrierIdEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof WriteEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof ReadEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof FunctionEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof CommitEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class BarrierFigure extends Ellipse {

		/**
		 * @generated
		 */
		private WrappingLabel fBarrierFigureLabelId;
		/**
		 * @generated
		 */
		private WrappingLabel fBarrierFigureLabelUid;
		/**
		 * @generated
		 */
		private WrappingLabel fBarrierFigureLabelIsStart;

		/**
		 * @generated
		 */
		public BarrierFigure() {

			GridLayout layoutThis = new GridLayout();
			layoutThis.numColumns = 2;
			layoutThis.makeColumnsEqualWidth = true;
			this.setLayoutManager(layoutThis);

			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrappingLabel barrierFigureLabelTitle0 = new WrappingLabel();

			barrierFigureLabelTitle0.setText("   Barrier   ");
			barrierFigureLabelTitle0
					.setForegroundColor(BARRIERFIGURELABELTITLE0_FORE);

			barrierFigureLabelTitle0.setFont(BARRIERFIGURELABELTITLE0_FONT);

			GridData constraintBarrierFigureLabelTitle0 = new GridData();
			constraintBarrierFigureLabelTitle0.verticalAlignment = GridData.CENTER;
			constraintBarrierFigureLabelTitle0.horizontalAlignment = GridData.CENTER;
			constraintBarrierFigureLabelTitle0.horizontalIndent = 0;
			constraintBarrierFigureLabelTitle0.horizontalSpan = 2;
			constraintBarrierFigureLabelTitle0.verticalSpan = 1;
			constraintBarrierFigureLabelTitle0.grabExcessHorizontalSpace = true;
			constraintBarrierFigureLabelTitle0.grabExcessVerticalSpace = true;
			this.add(barrierFigureLabelTitle0,
					constraintBarrierFigureLabelTitle0);

			WrappingLabel barrierFigureLabelIdTitle0 = new WrappingLabel();

			barrierFigureLabelIdTitle0.setText("Id:");

			GridData constraintBarrierFigureLabelIdTitle0 = new GridData();
			constraintBarrierFigureLabelIdTitle0.verticalAlignment = GridData.CENTER;
			constraintBarrierFigureLabelIdTitle0.horizontalAlignment = GridData.END;
			constraintBarrierFigureLabelIdTitle0.horizontalIndent = 0;
			constraintBarrierFigureLabelIdTitle0.horizontalSpan = 1;
			constraintBarrierFigureLabelIdTitle0.verticalSpan = 1;
			constraintBarrierFigureLabelIdTitle0.grabExcessHorizontalSpace = true;
			constraintBarrierFigureLabelIdTitle0.grabExcessVerticalSpace = true;
			this.add(barrierFigureLabelIdTitle0,
					constraintBarrierFigureLabelIdTitle0);

			fBarrierFigureLabelId = new WrappingLabel();

			fBarrierFigureLabelId.setText("<UID>");

			GridData constraintFBarrierFigureLabelId = new GridData();
			constraintFBarrierFigureLabelId.verticalAlignment = GridData.CENTER;
			constraintFBarrierFigureLabelId.horizontalAlignment = GridData.BEGINNING;
			constraintFBarrierFigureLabelId.horizontalIndent = 2;
			constraintFBarrierFigureLabelId.horizontalSpan = 1;
			constraintFBarrierFigureLabelId.verticalSpan = 1;
			constraintFBarrierFigureLabelId.grabExcessHorizontalSpace = true;
			constraintFBarrierFigureLabelId.grabExcessVerticalSpace = true;
			this.add(fBarrierFigureLabelId, constraintFBarrierFigureLabelId);

			WrappingLabel barrierFigureLabelUidTitle0 = new WrappingLabel();

			barrierFigureLabelUidTitle0.setText("uid");

			barrierFigureLabelUidTitle0
					.setFont(BARRIERFIGURELABELUIDTITLE0_FONT);

			GridData constraintBarrierFigureLabelUidTitle0 = new GridData();
			constraintBarrierFigureLabelUidTitle0.verticalAlignment = GridData.CENTER;
			constraintBarrierFigureLabelUidTitle0.horizontalAlignment = GridData.END;
			constraintBarrierFigureLabelUidTitle0.horizontalIndent = 0;
			constraintBarrierFigureLabelUidTitle0.horizontalSpan = 1;
			constraintBarrierFigureLabelUidTitle0.verticalSpan = 1;
			constraintBarrierFigureLabelUidTitle0.grabExcessHorizontalSpace = true;
			constraintBarrierFigureLabelUidTitle0.grabExcessVerticalSpace = true;
			this.add(barrierFigureLabelUidTitle0,
					constraintBarrierFigureLabelUidTitle0);

			fBarrierFigureLabelUid = new WrappingLabel();

			fBarrierFigureLabelUid.setText("1");

			fBarrierFigureLabelUid.setFont(FBARRIERFIGURELABELUID_FONT);

			GridData constraintFBarrierFigureLabelUid = new GridData();
			constraintFBarrierFigureLabelUid.verticalAlignment = GridData.CENTER;
			constraintFBarrierFigureLabelUid.horizontalAlignment = GridData.BEGINNING;
			constraintFBarrierFigureLabelUid.horizontalIndent = 2;
			constraintFBarrierFigureLabelUid.horizontalSpan = 1;
			constraintFBarrierFigureLabelUid.verticalSpan = 1;
			constraintFBarrierFigureLabelUid.grabExcessHorizontalSpace = true;
			constraintFBarrierFigureLabelUid.grabExcessVerticalSpace = true;
			this.add(fBarrierFigureLabelUid, constraintFBarrierFigureLabelUid);

			fBarrierFigureLabelIsStart = new WrappingLabel();

			fBarrierFigureLabelIsStart.setText("false");

			fBarrierFigureLabelIsStart.setFont(FBARRIERFIGURELABELISSTART_FONT);

			GridData constraintFBarrierFigureLabelIsStart = new GridData();
			constraintFBarrierFigureLabelIsStart.verticalAlignment = GridData.CENTER;
			constraintFBarrierFigureLabelIsStart.horizontalAlignment = GridData.CENTER;
			constraintFBarrierFigureLabelIsStart.horizontalIndent = 0;
			constraintFBarrierFigureLabelIsStart.horizontalSpan = 2;
			constraintFBarrierFigureLabelIsStart.verticalSpan = 1;
			constraintFBarrierFigureLabelIsStart.grabExcessHorizontalSpace = true;
			constraintFBarrierFigureLabelIsStart.grabExcessVerticalSpace = true;
			this.add(fBarrierFigureLabelIsStart,
					constraintFBarrierFigureLabelIsStart);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getBarrierFigureLabelId() {
			return fBarrierFigureLabelId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getBarrierFigureLabelUid() {
			return fBarrierFigureLabelUid;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getBarrierFigureLabelIsStart() {
			return fBarrierFigureLabelIsStart;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 245, 0, 0);

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 255, 229, 229);

	/**
	 * @generated
	 */
	static final Color BARRIERFIGURELABELTITLE0_FORE = new Color(null, 48, 48,
			48);

	/**
	 * @generated
	 */
	static final Font BARRIERFIGURELABELTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 9, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font BARRIERFIGURELABELUIDTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FBARRIERFIGURELABELUID_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FBARRIERFIGURELABELISSTART_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

}
