package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.CommitItemSemanticEditPolicy;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class CommitEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2005;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public CommitEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new CommitItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new CommitFigure();
	}

	/**
	 * @generated
	 */
	public CommitFigure getPrimaryShape() {
		return (CommitFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CommitIdEditPart) {
			((CommitIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getCommitFigureLabelId());
			return true;
		}
		if (childEditPart instanceof CommitUidEditPart) {
			((CommitUidEditPart) childEditPart).setLabel(getPrimaryShape()
					.getCommitFigureLabelUid());
			return true;
		}
		if (childEditPart instanceof CommitVariableEditPart) {
			((CommitVariableEditPart) childEditPart).setLabel(getPrimaryShape()
					.getCommitFigureLabelVariable());
			return true;
		}
		if (childEditPart instanceof CommitWIdEditPart) {
			((CommitWIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getCommitFigureLabelWId());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CommitIdEditPart) {
			return true;
		}
		if (childEditPart instanceof CommitUidEditPart) {
			return true;
		}
		if (childEditPart instanceof CommitVariableEditPart) {
			return true;
		}
		if (childEditPart instanceof CommitWIdEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(TSOVisualIDRegistry
				.getType(CommitIdEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof WriteEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof ReadEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof BarrierEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof FunctionEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class CommitFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fCommitFigureLabelId;
		/**
		 * @generated
		 */
		private WrappingLabel fCommitFigureLabelUid;
		/**
		 * @generated
		 */
		private WrappingLabel fCommitFigureLabelWId;
		/**
		 * @generated
		 */
		private WrappingLabel fCommitFigureLabelVariable;

		/**
		 * @generated
		 */
		public CommitFigure() {

			GridLayout layoutThis = new GridLayout();
			layoutThis.numColumns = 2;
			layoutThis.makeColumnsEqualWidth = true;
			this.setLayoutManager(layoutThis);

			this.setLineWidth(3);
			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrappingLabel commitFigureLabelTitle0 = new WrappingLabel();

			commitFigureLabelTitle0.setText("Commit");

			commitFigureLabelTitle0.setFont(COMMITFIGURELABELTITLE0_FONT);

			GridData constraintCommitFigureLabelTitle0 = new GridData();
			constraintCommitFigureLabelTitle0.verticalAlignment = GridData.CENTER;
			constraintCommitFigureLabelTitle0.horizontalAlignment = GridData.CENTER;
			constraintCommitFigureLabelTitle0.horizontalIndent = 0;
			constraintCommitFigureLabelTitle0.horizontalSpan = 2;
			constraintCommitFigureLabelTitle0.verticalSpan = 1;
			constraintCommitFigureLabelTitle0.grabExcessHorizontalSpace = true;
			constraintCommitFigureLabelTitle0.grabExcessVerticalSpace = true;
			this.add(commitFigureLabelTitle0, constraintCommitFigureLabelTitle0);

			WrappingLabel commitFigureLabelIdTitle0 = new WrappingLabel();

			commitFigureLabelIdTitle0.setText("Id:");

			GridData constraintCommitFigureLabelIdTitle0 = new GridData();
			constraintCommitFigureLabelIdTitle0.verticalAlignment = GridData.CENTER;
			constraintCommitFigureLabelIdTitle0.horizontalAlignment = GridData.END;
			constraintCommitFigureLabelIdTitle0.horizontalIndent = 0;
			constraintCommitFigureLabelIdTitle0.horizontalSpan = 1;
			constraintCommitFigureLabelIdTitle0.verticalSpan = 1;
			constraintCommitFigureLabelIdTitle0.grabExcessHorizontalSpace = true;
			constraintCommitFigureLabelIdTitle0.grabExcessVerticalSpace = true;
			this.add(commitFigureLabelIdTitle0,
					constraintCommitFigureLabelIdTitle0);

			fCommitFigureLabelId = new WrappingLabel();

			fCommitFigureLabelId.setText("<UID>");

			GridData constraintFCommitFigureLabelId = new GridData();
			constraintFCommitFigureLabelId.verticalAlignment = GridData.CENTER;
			constraintFCommitFigureLabelId.horizontalAlignment = GridData.BEGINNING;
			constraintFCommitFigureLabelId.horizontalIndent = 2;
			constraintFCommitFigureLabelId.horizontalSpan = 1;
			constraintFCommitFigureLabelId.verticalSpan = 1;
			constraintFCommitFigureLabelId.grabExcessHorizontalSpace = true;
			constraintFCommitFigureLabelId.grabExcessVerticalSpace = true;
			this.add(fCommitFigureLabelId, constraintFCommitFigureLabelId);

			WrappingLabel commitFigureLabelUidTitle0 = new WrappingLabel();

			commitFigureLabelUidTitle0.setText("uid");

			commitFigureLabelUidTitle0.setFont(COMMITFIGURELABELUIDTITLE0_FONT);

			GridData constraintCommitFigureLabelUidTitle0 = new GridData();
			constraintCommitFigureLabelUidTitle0.verticalAlignment = GridData.CENTER;
			constraintCommitFigureLabelUidTitle0.horizontalAlignment = GridData.END;
			constraintCommitFigureLabelUidTitle0.horizontalIndent = 0;
			constraintCommitFigureLabelUidTitle0.horizontalSpan = 1;
			constraintCommitFigureLabelUidTitle0.verticalSpan = 1;
			constraintCommitFigureLabelUidTitle0.grabExcessHorizontalSpace = true;
			constraintCommitFigureLabelUidTitle0.grabExcessVerticalSpace = true;
			this.add(commitFigureLabelUidTitle0,
					constraintCommitFigureLabelUidTitle0);

			fCommitFigureLabelUid = new WrappingLabel();

			fCommitFigureLabelUid.setText("1");

			fCommitFigureLabelUid.setFont(FCOMMITFIGURELABELUID_FONT);

			GridData constraintFCommitFigureLabelUid = new GridData();
			constraintFCommitFigureLabelUid.verticalAlignment = GridData.CENTER;
			constraintFCommitFigureLabelUid.horizontalAlignment = GridData.BEGINNING;
			constraintFCommitFigureLabelUid.horizontalIndent = 2;
			constraintFCommitFigureLabelUid.horizontalSpan = 1;
			constraintFCommitFigureLabelUid.verticalSpan = 1;
			constraintFCommitFigureLabelUid.grabExcessHorizontalSpace = true;
			constraintFCommitFigureLabelUid.grabExcessVerticalSpace = true;
			this.add(fCommitFigureLabelUid, constraintFCommitFigureLabelUid);

			WrappingLabel commitFigureLabelVariableTitle0 = new WrappingLabel();

			commitFigureLabelVariableTitle0.setText("var:");

			GridData constraintCommitFigureLabelVariableTitle0 = new GridData();
			constraintCommitFigureLabelVariableTitle0.verticalAlignment = GridData.CENTER;
			constraintCommitFigureLabelVariableTitle0.horizontalAlignment = GridData.END;
			constraintCommitFigureLabelVariableTitle0.horizontalIndent = 0;
			constraintCommitFigureLabelVariableTitle0.horizontalSpan = 1;
			constraintCommitFigureLabelVariableTitle0.verticalSpan = 1;
			constraintCommitFigureLabelVariableTitle0.grabExcessHorizontalSpace = true;
			constraintCommitFigureLabelVariableTitle0.grabExcessVerticalSpace = true;
			this.add(commitFigureLabelVariableTitle0,
					constraintCommitFigureLabelVariableTitle0);

			fCommitFigureLabelVariable = new WrappingLabel();

			fCommitFigureLabelVariable.setText("<var>");

			GridData constraintFCommitFigureLabelVariable = new GridData();
			constraintFCommitFigureLabelVariable.verticalAlignment = GridData.CENTER;
			constraintFCommitFigureLabelVariable.horizontalAlignment = GridData.BEGINNING;
			constraintFCommitFigureLabelVariable.horizontalIndent = 2;
			constraintFCommitFigureLabelVariable.horizontalSpan = 1;
			constraintFCommitFigureLabelVariable.verticalSpan = 1;
			constraintFCommitFigureLabelVariable.grabExcessHorizontalSpace = true;
			constraintFCommitFigureLabelVariable.grabExcessVerticalSpace = true;
			this.add(fCommitFigureLabelVariable,
					constraintFCommitFigureLabelVariable);

			WrappingLabel commitFigureLabelWIdTitle0 = new WrappingLabel();

			commitFigureLabelWIdTitle0.setText("wId:");

			GridData constraintCommitFigureLabelWIdTitle0 = new GridData();
			constraintCommitFigureLabelWIdTitle0.verticalAlignment = GridData.CENTER;
			constraintCommitFigureLabelWIdTitle0.horizontalAlignment = GridData.END;
			constraintCommitFigureLabelWIdTitle0.horizontalIndent = 0;
			constraintCommitFigureLabelWIdTitle0.horizontalSpan = 1;
			constraintCommitFigureLabelWIdTitle0.verticalSpan = 1;
			constraintCommitFigureLabelWIdTitle0.grabExcessHorizontalSpace = true;
			constraintCommitFigureLabelWIdTitle0.grabExcessVerticalSpace = true;
			this.add(commitFigureLabelWIdTitle0,
					constraintCommitFigureLabelWIdTitle0);

			fCommitFigureLabelWId = new WrappingLabel();

			fCommitFigureLabelWId.setText("<wId>");

			GridData constraintFCommitFigureLabelWId = new GridData();
			constraintFCommitFigureLabelWId.verticalAlignment = GridData.CENTER;
			constraintFCommitFigureLabelWId.horizontalAlignment = GridData.BEGINNING;
			constraintFCommitFigureLabelWId.horizontalIndent = 2;
			constraintFCommitFigureLabelWId.horizontalSpan = 1;
			constraintFCommitFigureLabelWId.verticalSpan = 1;
			constraintFCommitFigureLabelWId.grabExcessHorizontalSpace = true;
			constraintFCommitFigureLabelWId.grabExcessVerticalSpace = true;
			this.add(fCommitFigureLabelWId, constraintFCommitFigureLabelWId);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getCommitFigureLabelId() {
			return fCommitFigureLabelId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getCommitFigureLabelUid() {
			return fCommitFigureLabelUid;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getCommitFigureLabelWId() {
			return fCommitFigureLabelWId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getCommitFigureLabelVariable() {
			return fCommitFigureLabelVariable;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 86, 86, 86);

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 255, 255, 236);

	/**
	 * @generated
	 */
	static final Font COMMITFIGURELABELTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 9, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font COMMITFIGURELABELUIDTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FCOMMITFIGURELABELUID_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

}
