package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.FunctionItemSemanticEditPolicy;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class FunctionEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2004;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public FunctionEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new FunctionItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new FunctionFigure();
	}

	/**
	 * @generated
	 */
	public FunctionFigure getPrimaryShape() {
		return (FunctionFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof FunctionIdEditPart) {
			((FunctionIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFunctionFigureLabelId());
			return true;
		}
		if (childEditPart instanceof FunctionUidEditPart) {
			((FunctionUidEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFunctionFigureLabelUid());
			return true;
		}
		if (childEditPart instanceof FunctionNameEditPart) {
			((FunctionNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFunctionFigureLabelName());
			return true;
		}
		if (childEditPart instanceof FunctionIsStartEditPart) {
			((FunctionIsStartEditPart) childEditPart)
					.setLabel(getPrimaryShape().getFunctionFigureLabelIsStart());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof FunctionIdEditPart) {
			return true;
		}
		if (childEditPart instanceof FunctionUidEditPart) {
			return true;
		}
		if (childEditPart instanceof FunctionNameEditPart) {
			return true;
		}
		if (childEditPart instanceof FunctionIsStartEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(TSOVisualIDRegistry
				.getType(FunctionIdEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof WriteEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof ReadEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof BarrierEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof CommitEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class FunctionFigure extends Ellipse {

		/**
		 * @generated
		 */
		private WrappingLabel fFunctionFigureLabelId;
		/**
		 * @generated
		 */
		private WrappingLabel fFunctionFigureLabelUid;
		/**
		 * @generated
		 */
		private WrappingLabel fFunctionFigureLabelName;
		/**
		 * @generated
		 */
		private WrappingLabel fFunctionFigureLabelIsStart;

		/**
		 * @generated
		 */
		public FunctionFigure() {

			GridLayout layoutThis = new GridLayout();
			layoutThis.numColumns = 2;
			layoutThis.makeColumnsEqualWidth = true;
			this.setLayoutManager(layoutThis);

			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrappingLabel functionFigureLabelTitle0 = new WrappingLabel();

			functionFigureLabelTitle0.setText("f( )");
			functionFigureLabelTitle0
					.setForegroundColor(FUNCTIONFIGURELABELTITLE0_FORE);

			functionFigureLabelTitle0.setFont(FUNCTIONFIGURELABELTITLE0_FONT);

			GridData constraintFunctionFigureLabelTitle0 = new GridData();
			constraintFunctionFigureLabelTitle0.verticalAlignment = GridData.CENTER;
			constraintFunctionFigureLabelTitle0.horizontalAlignment = GridData.CENTER;
			constraintFunctionFigureLabelTitle0.horizontalIndent = 0;
			constraintFunctionFigureLabelTitle0.horizontalSpan = 2;
			constraintFunctionFigureLabelTitle0.verticalSpan = 1;
			constraintFunctionFigureLabelTitle0.grabExcessHorizontalSpace = true;
			constraintFunctionFigureLabelTitle0.grabExcessVerticalSpace = true;
			this.add(functionFigureLabelTitle0,
					constraintFunctionFigureLabelTitle0);

			WrappingLabel functionFigureLabelIdTitle0 = new WrappingLabel();

			functionFigureLabelIdTitle0.setText("Id:");

			GridData constraintFunctionFigureLabelIdTitle0 = new GridData();
			constraintFunctionFigureLabelIdTitle0.verticalAlignment = GridData.CENTER;
			constraintFunctionFigureLabelIdTitle0.horizontalAlignment = GridData.END;
			constraintFunctionFigureLabelIdTitle0.horizontalIndent = 0;
			constraintFunctionFigureLabelIdTitle0.horizontalSpan = 1;
			constraintFunctionFigureLabelIdTitle0.verticalSpan = 1;
			constraintFunctionFigureLabelIdTitle0.grabExcessHorizontalSpace = true;
			constraintFunctionFigureLabelIdTitle0.grabExcessVerticalSpace = true;
			this.add(functionFigureLabelIdTitle0,
					constraintFunctionFigureLabelIdTitle0);

			fFunctionFigureLabelId = new WrappingLabel();

			fFunctionFigureLabelId.setText("<UID>");

			GridData constraintFFunctionFigureLabelId = new GridData();
			constraintFFunctionFigureLabelId.verticalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelId.horizontalAlignment = GridData.BEGINNING;
			constraintFFunctionFigureLabelId.horizontalIndent = 2;
			constraintFFunctionFigureLabelId.horizontalSpan = 1;
			constraintFFunctionFigureLabelId.verticalSpan = 1;
			constraintFFunctionFigureLabelId.grabExcessHorizontalSpace = true;
			constraintFFunctionFigureLabelId.grabExcessVerticalSpace = true;
			this.add(fFunctionFigureLabelId, constraintFFunctionFigureLabelId);

			WrappingLabel functionFigureLabelUidTitle0 = new WrappingLabel();

			functionFigureLabelUidTitle0.setText("uid");

			functionFigureLabelUidTitle0
					.setFont(FUNCTIONFIGURELABELUIDTITLE0_FONT);

			GridData constraintFunctionFigureLabelUidTitle0 = new GridData();
			constraintFunctionFigureLabelUidTitle0.verticalAlignment = GridData.CENTER;
			constraintFunctionFigureLabelUidTitle0.horizontalAlignment = GridData.END;
			constraintFunctionFigureLabelUidTitle0.horizontalIndent = 0;
			constraintFunctionFigureLabelUidTitle0.horizontalSpan = 1;
			constraintFunctionFigureLabelUidTitle0.verticalSpan = 1;
			constraintFunctionFigureLabelUidTitle0.grabExcessHorizontalSpace = true;
			constraintFunctionFigureLabelUidTitle0.grabExcessVerticalSpace = true;
			this.add(functionFigureLabelUidTitle0,
					constraintFunctionFigureLabelUidTitle0);

			fFunctionFigureLabelUid = new WrappingLabel();

			fFunctionFigureLabelUid.setText("1");

			fFunctionFigureLabelUid.setFont(FFUNCTIONFIGURELABELUID_FONT);

			GridData constraintFFunctionFigureLabelUid = new GridData();
			constraintFFunctionFigureLabelUid.verticalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelUid.horizontalAlignment = GridData.BEGINNING;
			constraintFFunctionFigureLabelUid.horizontalIndent = 2;
			constraintFFunctionFigureLabelUid.horizontalSpan = 1;
			constraintFFunctionFigureLabelUid.verticalSpan = 1;
			constraintFFunctionFigureLabelUid.grabExcessHorizontalSpace = true;
			constraintFFunctionFigureLabelUid.grabExcessVerticalSpace = true;
			this.add(fFunctionFigureLabelUid, constraintFFunctionFigureLabelUid);

			fFunctionFigureLabelName = new WrappingLabel();

			fFunctionFigureLabelName.setText("function");

			GridData constraintFFunctionFigureLabelName = new GridData();
			constraintFFunctionFigureLabelName.verticalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelName.horizontalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelName.horizontalIndent = 0;
			constraintFFunctionFigureLabelName.horizontalSpan = 2;
			constraintFFunctionFigureLabelName.verticalSpan = 1;
			constraintFFunctionFigureLabelName.grabExcessHorizontalSpace = true;
			constraintFFunctionFigureLabelName.grabExcessVerticalSpace = true;
			this.add(fFunctionFigureLabelName,
					constraintFFunctionFigureLabelName);

			fFunctionFigureLabelIsStart = new WrappingLabel();

			fFunctionFigureLabelIsStart.setText("false");

			fFunctionFigureLabelIsStart
					.setFont(FFUNCTIONFIGURELABELISSTART_FONT);

			GridData constraintFFunctionFigureLabelIsStart = new GridData();
			constraintFFunctionFigureLabelIsStart.verticalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelIsStart.horizontalAlignment = GridData.CENTER;
			constraintFFunctionFigureLabelIsStart.horizontalIndent = 0;
			constraintFFunctionFigureLabelIsStart.horizontalSpan = 2;
			constraintFFunctionFigureLabelIsStart.verticalSpan = 1;
			constraintFFunctionFigureLabelIsStart.grabExcessHorizontalSpace = true;
			constraintFFunctionFigureLabelIsStart.grabExcessVerticalSpace = true;
			this.add(fFunctionFigureLabelIsStart,
					constraintFFunctionFigureLabelIsStart);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFunctionFigureLabelId() {
			return fFunctionFigureLabelId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFunctionFigureLabelUid() {
			return fFunctionFigureLabelUid;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFunctionFigureLabelName() {
			return fFunctionFigureLabelName;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFunctionFigureLabelIsStart() {
			return fFunctionFigureLabelIsStart;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 137, 0, 216);

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 237, 232, 237);

	/**
	 * @generated
	 */
	static final Color FUNCTIONFIGURELABELTITLE0_FORE = new Color(null, 32, 32,
			32);

	/**
	 * @generated
	 */
	static final Font FUNCTIONFIGURELABELTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 9, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FUNCTIONFIGURELABELUIDTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FFUNCTIONFIGURELABELUID_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FFUNCTIONFIGURELABELISSTART_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

}
