package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.ReadItemSemanticEditPolicy;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class ReadEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2002;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ReadEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new ReadItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new ReadFigure();
	}

	/**
	 * @generated
	 */
	public ReadFigure getPrimaryShape() {
		return (ReadFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ReadIdEditPart) {
			((ReadIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getReadFigureLabelId());
			return true;
		}
		if (childEditPart instanceof ReadUidEditPart) {
			((ReadUidEditPart) childEditPart).setLabel(getPrimaryShape()
					.getReadFigureLabelUid());
			return true;
		}
		if (childEditPart instanceof ReadVariableEditPart) {
			((ReadVariableEditPart) childEditPart).setLabel(getPrimaryShape()
					.getReadFigureLabelVariable());
			return true;
		}
		if (childEditPart instanceof ReadIsStartEditPart) {
			((ReadIsStartEditPart) childEditPart).setLabel(getPrimaryShape()
					.getReadFigureLabelIsStart());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ReadIdEditPart) {
			return true;
		}
		if (childEditPart instanceof ReadUidEditPart) {
			return true;
		}
		if (childEditPart instanceof ReadVariableEditPart) {
			return true;
		}
		if (childEditPart instanceof ReadIsStartEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(TSOVisualIDRegistry
				.getType(ReadIdEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof WriteEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof BarrierEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof FunctionEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof CommitEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(TSOElementTypes.Transition_4001);
		types.add(TSOElementTypes.Synch_4002);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		} else if (relationshipType == TSOElementTypes.Synch_4002) {
			types.add(TSOElementTypes.Write_2001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class ReadFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fReadFigureLabelId;
		/**
		 * @generated
		 */
		private WrappingLabel fReadFigureLabelUid;
		/**
		 * @generated
		 */
		private WrappingLabel fReadFigureLabelVariable;
		/**
		 * @generated
		 */
		private WrappingLabel fReadFigureLabelIsStart;

		/**
		 * @generated
		 */
		public ReadFigure() {

			GridLayout layoutThis = new GridLayout();
			layoutThis.numColumns = 2;
			layoutThis.makeColumnsEqualWidth = true;
			this.setLayoutManager(layoutThis);

			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(12),
					getMapMode().DPtoLP(12)));
			this.setLineWidth(3);
			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrappingLabel readFigureLabelTitle0 = new WrappingLabel();

			readFigureLabelTitle0.setText("Read");

			readFigureLabelTitle0.setFont(READFIGURELABELTITLE0_FONT);

			GridData constraintReadFigureLabelTitle0 = new GridData();
			constraintReadFigureLabelTitle0.verticalAlignment = GridData.CENTER;
			constraintReadFigureLabelTitle0.horizontalAlignment = GridData.CENTER;
			constraintReadFigureLabelTitle0.horizontalIndent = 0;
			constraintReadFigureLabelTitle0.horizontalSpan = 2;
			constraintReadFigureLabelTitle0.verticalSpan = 1;
			constraintReadFigureLabelTitle0.grabExcessHorizontalSpace = true;
			constraintReadFigureLabelTitle0.grabExcessVerticalSpace = true;
			this.add(readFigureLabelTitle0, constraintReadFigureLabelTitle0);

			WrappingLabel readFigureLabelIdTitle0 = new WrappingLabel();

			readFigureLabelIdTitle0.setText("Id:");

			GridData constraintReadFigureLabelIdTitle0 = new GridData();
			constraintReadFigureLabelIdTitle0.verticalAlignment = GridData.CENTER;
			constraintReadFigureLabelIdTitle0.horizontalAlignment = GridData.END;
			constraintReadFigureLabelIdTitle0.horizontalIndent = 0;
			constraintReadFigureLabelIdTitle0.horizontalSpan = 1;
			constraintReadFigureLabelIdTitle0.verticalSpan = 1;
			constraintReadFigureLabelIdTitle0.grabExcessHorizontalSpace = true;
			constraintReadFigureLabelIdTitle0.grabExcessVerticalSpace = true;
			this.add(readFigureLabelIdTitle0, constraintReadFigureLabelIdTitle0);

			fReadFigureLabelId = new WrappingLabel();

			fReadFigureLabelId.setText("<UID>");

			GridData constraintFReadFigureLabelId = new GridData();
			constraintFReadFigureLabelId.verticalAlignment = GridData.CENTER;
			constraintFReadFigureLabelId.horizontalAlignment = GridData.BEGINNING;
			constraintFReadFigureLabelId.horizontalIndent = 2;
			constraintFReadFigureLabelId.horizontalSpan = 1;
			constraintFReadFigureLabelId.verticalSpan = 1;
			constraintFReadFigureLabelId.grabExcessHorizontalSpace = true;
			constraintFReadFigureLabelId.grabExcessVerticalSpace = true;
			this.add(fReadFigureLabelId, constraintFReadFigureLabelId);

			WrappingLabel readFigureLabelUidTitle0 = new WrappingLabel();

			readFigureLabelUidTitle0.setText("uid");

			readFigureLabelUidTitle0.setFont(READFIGURELABELUIDTITLE0_FONT);

			GridData constraintReadFigureLabelUidTitle0 = new GridData();
			constraintReadFigureLabelUidTitle0.verticalAlignment = GridData.CENTER;
			constraintReadFigureLabelUidTitle0.horizontalAlignment = GridData.END;
			constraintReadFigureLabelUidTitle0.horizontalIndent = 0;
			constraintReadFigureLabelUidTitle0.horizontalSpan = 1;
			constraintReadFigureLabelUidTitle0.verticalSpan = 1;
			constraintReadFigureLabelUidTitle0.grabExcessHorizontalSpace = true;
			constraintReadFigureLabelUidTitle0.grabExcessVerticalSpace = true;
			this.add(readFigureLabelUidTitle0,
					constraintReadFigureLabelUidTitle0);

			fReadFigureLabelUid = new WrappingLabel();

			fReadFigureLabelUid.setText("1");

			fReadFigureLabelUid.setFont(FREADFIGURELABELUID_FONT);

			GridData constraintFReadFigureLabelUid = new GridData();
			constraintFReadFigureLabelUid.verticalAlignment = GridData.CENTER;
			constraintFReadFigureLabelUid.horizontalAlignment = GridData.BEGINNING;
			constraintFReadFigureLabelUid.horizontalIndent = 2;
			constraintFReadFigureLabelUid.horizontalSpan = 1;
			constraintFReadFigureLabelUid.verticalSpan = 1;
			constraintFReadFigureLabelUid.grabExcessHorizontalSpace = true;
			constraintFReadFigureLabelUid.grabExcessVerticalSpace = true;
			this.add(fReadFigureLabelUid, constraintFReadFigureLabelUid);

			WrappingLabel readFigureLabelVariableTitle0 = new WrappingLabel();

			readFigureLabelVariableTitle0.setText("var:");

			GridData constraintReadFigureLabelVariableTitle0 = new GridData();
			constraintReadFigureLabelVariableTitle0.verticalAlignment = GridData.CENTER;
			constraintReadFigureLabelVariableTitle0.horizontalAlignment = GridData.END;
			constraintReadFigureLabelVariableTitle0.horizontalIndent = 0;
			constraintReadFigureLabelVariableTitle0.horizontalSpan = 1;
			constraintReadFigureLabelVariableTitle0.verticalSpan = 1;
			constraintReadFigureLabelVariableTitle0.grabExcessHorizontalSpace = true;
			constraintReadFigureLabelVariableTitle0.grabExcessVerticalSpace = true;
			this.add(readFigureLabelVariableTitle0,
					constraintReadFigureLabelVariableTitle0);

			fReadFigureLabelVariable = new WrappingLabel();

			fReadFigureLabelVariable.setText("<var>");

			GridData constraintFReadFigureLabelVariable = new GridData();
			constraintFReadFigureLabelVariable.verticalAlignment = GridData.CENTER;
			constraintFReadFigureLabelVariable.horizontalAlignment = GridData.BEGINNING;
			constraintFReadFigureLabelVariable.horizontalIndent = 2;
			constraintFReadFigureLabelVariable.horizontalSpan = 1;
			constraintFReadFigureLabelVariable.verticalSpan = 1;
			constraintFReadFigureLabelVariable.grabExcessHorizontalSpace = true;
			constraintFReadFigureLabelVariable.grabExcessVerticalSpace = true;
			this.add(fReadFigureLabelVariable,
					constraintFReadFigureLabelVariable);

			fReadFigureLabelIsStart = new WrappingLabel();

			fReadFigureLabelIsStart.setText("false");

			fReadFigureLabelIsStart.setFont(FREADFIGURELABELISSTART_FONT);

			GridData constraintFReadFigureLabelIsStart = new GridData();
			constraintFReadFigureLabelIsStart.verticalAlignment = GridData.CENTER;
			constraintFReadFigureLabelIsStart.horizontalAlignment = GridData.CENTER;
			constraintFReadFigureLabelIsStart.horizontalIndent = 0;
			constraintFReadFigureLabelIsStart.horizontalSpan = 2;
			constraintFReadFigureLabelIsStart.verticalSpan = 2;
			constraintFReadFigureLabelIsStart.grabExcessHorizontalSpace = true;
			constraintFReadFigureLabelIsStart.grabExcessVerticalSpace = true;
			this.add(fReadFigureLabelIsStart, constraintFReadFigureLabelIsStart);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getReadFigureLabelId() {
			return fReadFigureLabelId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getReadFigureLabelUid() {
			return fReadFigureLabelUid;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getReadFigureLabelVariable() {
			return fReadFigureLabelVariable;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getReadFigureLabelIsStart() {
			return fReadFigureLabelIsStart;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 78, 140, 159);

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 245, 255, 255);

	/**
	 * @generated
	 */
	static final Font READFIGURELABELTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 9, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font READFIGURELABELUIDTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FREADFIGURELABELUID_FONT = new Font(Display.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(), 8,
			SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FREADFIGURELABELISSTART_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

}
