package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;

/**
 * @generated
 */
public class TSOEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (TSOVisualIDRegistry.getVisualID(view)) {

			case TSOReadWriteSynchEditPart.VISUAL_ID:
				return new TSOReadWriteSynchEditPart(view);

			case WriteEditPart.VISUAL_ID:
				return new WriteEditPart(view);

			case WriteIdEditPart.VISUAL_ID:
				return new WriteIdEditPart(view);

			case WriteUidEditPart.VISUAL_ID:
				return new WriteUidEditPart(view);

			case WriteVariableEditPart.VISUAL_ID:
				return new WriteVariableEditPart(view);

			case WriteIsStartEditPart.VISUAL_ID:
				return new WriteIsStartEditPart(view);

			case ReadEditPart.VISUAL_ID:
				return new ReadEditPart(view);

			case ReadIdEditPart.VISUAL_ID:
				return new ReadIdEditPart(view);

			case ReadUidEditPart.VISUAL_ID:
				return new ReadUidEditPart(view);

			case ReadVariableEditPart.VISUAL_ID:
				return new ReadVariableEditPart(view);

			case ReadIsStartEditPart.VISUAL_ID:
				return new ReadIsStartEditPart(view);

			case BarrierEditPart.VISUAL_ID:
				return new BarrierEditPart(view);

			case BarrierIdEditPart.VISUAL_ID:
				return new BarrierIdEditPart(view);

			case BarrierUidEditPart.VISUAL_ID:
				return new BarrierUidEditPart(view);

			case BarrierIsStartEditPart.VISUAL_ID:
				return new BarrierIsStartEditPart(view);

			case FunctionEditPart.VISUAL_ID:
				return new FunctionEditPart(view);

			case FunctionIdEditPart.VISUAL_ID:
				return new FunctionIdEditPart(view);

			case FunctionUidEditPart.VISUAL_ID:
				return new FunctionUidEditPart(view);

			case FunctionNameEditPart.VISUAL_ID:
				return new FunctionNameEditPart(view);

			case FunctionIsStartEditPart.VISUAL_ID:
				return new FunctionIsStartEditPart(view);

			case CommitEditPart.VISUAL_ID:
				return new CommitEditPart(view);

			case CommitIdEditPart.VISUAL_ID:
				return new CommitIdEditPart(view);

			case CommitUidEditPart.VISUAL_ID:
				return new CommitUidEditPart(view);

			case CommitVariableEditPart.VISUAL_ID:
				return new CommitVariableEditPart(view);

			case CommitWIdEditPart.VISUAL_ID:
				return new CommitWIdEditPart(view);

			case TransitionEditPart.VISUAL_ID:
				return new TransitionEditPart(view);

			case SynchEditPart.VISUAL_ID:
				return new SynchEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}

}
