package edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.GridData;
import org.eclipse.draw2d.GridLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import edu.toronto.cs.se.modelepedia.tso.diagram.edit.policies.WriteItemSemanticEditPolicy;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class WriteEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2001;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public WriteEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new WriteItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child
						.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new WriteFigure();
	}

	/**
	 * @generated
	 */
	public WriteFigure getPrimaryShape() {
		return (WriteFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof WriteIdEditPart) {
			((WriteIdEditPart) childEditPart).setLabel(getPrimaryShape()
					.getWriteFigureLabelId());
			return true;
		}
		if (childEditPart instanceof WriteUidEditPart) {
			((WriteUidEditPart) childEditPart).setLabel(getPrimaryShape()
					.getWriteFigureLabelUid());
			return true;
		}
		if (childEditPart instanceof WriteVariableEditPart) {
			((WriteVariableEditPart) childEditPart).setLabel(getPrimaryShape()
					.getWriteFigureLabelVariable());
			return true;
		}
		if (childEditPart instanceof WriteIsStartEditPart) {
			((WriteIsStartEditPart) childEditPart).setLabel(getPrimaryShape()
					.getWriteFigureLabelIsStart());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof WriteIdEditPart) {
			return true;
		}
		if (childEditPart instanceof WriteUidEditPart) {
			return true;
		}
		if (childEditPart instanceof WriteVariableEditPart) {
			return true;
		}
		if (childEditPart instanceof WriteIsStartEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(TSOVisualIDRegistry
				.getType(WriteIdEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(2);
		types.add(TSOElementTypes.Transition_4001);
		types.add(TSOElementTypes.Synch_4002);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(
			IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof ReadEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof BarrierEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof FunctionEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof CommitEditPart) {
			types.add(TSOElementTypes.Transition_4001);
		}
		if (targetEditPart instanceof ReadEditPart) {
			types.add(TSOElementTypes.Synch_4002);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		} else if (relationshipType == TSOElementTypes.Synch_4002) {
			types.add(TSOElementTypes.Read_2002);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(TSOElementTypes.Transition_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == TSOElementTypes.Transition_4001) {
			types.add(TSOElementTypes.Write_2001);
			types.add(TSOElementTypes.Read_2002);
			types.add(TSOElementTypes.Barrier_2003);
			types.add(TSOElementTypes.Function_2004);
			types.add(TSOElementTypes.Commit_2005);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class WriteFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fWriteFigureLabelId;
		/**
		 * @generated
		 */
		private WrappingLabel fWriteFigureLabelUid;
		/**
		 * @generated
		 */
		private WrappingLabel fWriteFigureLabelVariable;
		/**
		 * @generated
		 */
		private WrappingLabel fWriteFigureLabelIsStart;

		/**
		 * @generated
		 */
		public WriteFigure() {

			GridLayout layoutThis = new GridLayout();
			layoutThis.numColumns = 2;
			layoutThis.makeColumnsEqualWidth = true;
			this.setLayoutManager(layoutThis);

			this.setLineStyle(Graphics.LINE_DOT);
			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			WrappingLabel writeFigureLabelTitle0 = new WrappingLabel();

			writeFigureLabelTitle0.setText("Write");

			writeFigureLabelTitle0.setFont(WRITEFIGURELABELTITLE0_FONT);

			GridData constraintWriteFigureLabelTitle0 = new GridData();
			constraintWriteFigureLabelTitle0.verticalAlignment = GridData.CENTER;
			constraintWriteFigureLabelTitle0.horizontalAlignment = GridData.CENTER;
			constraintWriteFigureLabelTitle0.horizontalIndent = 0;
			constraintWriteFigureLabelTitle0.horizontalSpan = 2;
			constraintWriteFigureLabelTitle0.verticalSpan = 1;
			constraintWriteFigureLabelTitle0.grabExcessHorizontalSpace = true;
			constraintWriteFigureLabelTitle0.grabExcessVerticalSpace = true;
			this.add(writeFigureLabelTitle0, constraintWriteFigureLabelTitle0);

			WrappingLabel writeFigureLabelIdTitle0 = new WrappingLabel();

			writeFigureLabelIdTitle0.setText("Id:");

			GridData constraintWriteFigureLabelIdTitle0 = new GridData();
			constraintWriteFigureLabelIdTitle0.verticalAlignment = GridData.CENTER;
			constraintWriteFigureLabelIdTitle0.horizontalAlignment = GridData.END;
			constraintWriteFigureLabelIdTitle0.horizontalIndent = 0;
			constraintWriteFigureLabelIdTitle0.horizontalSpan = 1;
			constraintWriteFigureLabelIdTitle0.verticalSpan = 1;
			constraintWriteFigureLabelIdTitle0.grabExcessHorizontalSpace = true;
			constraintWriteFigureLabelIdTitle0.grabExcessVerticalSpace = true;
			this.add(writeFigureLabelIdTitle0,
					constraintWriteFigureLabelIdTitle0);

			fWriteFigureLabelId = new WrappingLabel();

			fWriteFigureLabelId.setText("<id>");

			GridData constraintFWriteFigureLabelId = new GridData();
			constraintFWriteFigureLabelId.verticalAlignment = GridData.CENTER;
			constraintFWriteFigureLabelId.horizontalAlignment = GridData.BEGINNING;
			constraintFWriteFigureLabelId.horizontalIndent = 2;
			constraintFWriteFigureLabelId.horizontalSpan = 1;
			constraintFWriteFigureLabelId.verticalSpan = 1;
			constraintFWriteFigureLabelId.grabExcessHorizontalSpace = true;
			constraintFWriteFigureLabelId.grabExcessVerticalSpace = true;
			this.add(fWriteFigureLabelId, constraintFWriteFigureLabelId);

			WrappingLabel writeFigureLabelUidTitle0 = new WrappingLabel();

			writeFigureLabelUidTitle0.setText("uid");

			writeFigureLabelUidTitle0.setFont(WRITEFIGURELABELUIDTITLE0_FONT);

			GridData constraintWriteFigureLabelUidTitle0 = new GridData();
			constraintWriteFigureLabelUidTitle0.verticalAlignment = GridData.CENTER;
			constraintWriteFigureLabelUidTitle0.horizontalAlignment = GridData.END;
			constraintWriteFigureLabelUidTitle0.horizontalIndent = 0;
			constraintWriteFigureLabelUidTitle0.horizontalSpan = 1;
			constraintWriteFigureLabelUidTitle0.verticalSpan = 1;
			constraintWriteFigureLabelUidTitle0.grabExcessHorizontalSpace = true;
			constraintWriteFigureLabelUidTitle0.grabExcessVerticalSpace = true;
			this.add(writeFigureLabelUidTitle0,
					constraintWriteFigureLabelUidTitle0);

			fWriteFigureLabelUid = new WrappingLabel();

			fWriteFigureLabelUid.setText("1");

			fWriteFigureLabelUid.setFont(FWRITEFIGURELABELUID_FONT);

			GridData constraintFWriteFigureLabelUid = new GridData();
			constraintFWriteFigureLabelUid.verticalAlignment = GridData.CENTER;
			constraintFWriteFigureLabelUid.horizontalAlignment = GridData.BEGINNING;
			constraintFWriteFigureLabelUid.horizontalIndent = 2;
			constraintFWriteFigureLabelUid.horizontalSpan = 1;
			constraintFWriteFigureLabelUid.verticalSpan = 1;
			constraintFWriteFigureLabelUid.grabExcessHorizontalSpace = true;
			constraintFWriteFigureLabelUid.grabExcessVerticalSpace = true;
			this.add(fWriteFigureLabelUid, constraintFWriteFigureLabelUid);

			WrappingLabel writeFigureLabelVariableTitle0 = new WrappingLabel();

			writeFigureLabelVariableTitle0.setText("var:");

			GridData constraintWriteFigureLabelVariableTitle0 = new GridData();
			constraintWriteFigureLabelVariableTitle0.verticalAlignment = GridData.CENTER;
			constraintWriteFigureLabelVariableTitle0.horizontalAlignment = GridData.END;
			constraintWriteFigureLabelVariableTitle0.horizontalIndent = 0;
			constraintWriteFigureLabelVariableTitle0.horizontalSpan = 1;
			constraintWriteFigureLabelVariableTitle0.verticalSpan = 1;
			constraintWriteFigureLabelVariableTitle0.grabExcessHorizontalSpace = true;
			constraintWriteFigureLabelVariableTitle0.grabExcessVerticalSpace = true;
			this.add(writeFigureLabelVariableTitle0,
					constraintWriteFigureLabelVariableTitle0);

			fWriteFigureLabelVariable = new WrappingLabel();

			fWriteFigureLabelVariable.setText("<var>");

			GridData constraintFWriteFigureLabelVariable = new GridData();
			constraintFWriteFigureLabelVariable.verticalAlignment = GridData.CENTER;
			constraintFWriteFigureLabelVariable.horizontalAlignment = GridData.BEGINNING;
			constraintFWriteFigureLabelVariable.horizontalIndent = 2;
			constraintFWriteFigureLabelVariable.horizontalSpan = 1;
			constraintFWriteFigureLabelVariable.verticalSpan = 1;
			constraintFWriteFigureLabelVariable.grabExcessHorizontalSpace = true;
			constraintFWriteFigureLabelVariable.grabExcessVerticalSpace = true;
			this.add(fWriteFigureLabelVariable,
					constraintFWriteFigureLabelVariable);

			fWriteFigureLabelIsStart = new WrappingLabel();

			fWriteFigureLabelIsStart.setText("false");

			fWriteFigureLabelIsStart.setFont(FWRITEFIGURELABELISSTART_FONT);

			GridData constraintFWriteFigureLabelIsStart = new GridData();
			constraintFWriteFigureLabelIsStart.verticalAlignment = GridData.CENTER;
			constraintFWriteFigureLabelIsStart.horizontalAlignment = GridData.CENTER;
			constraintFWriteFigureLabelIsStart.horizontalIndent = 0;
			constraintFWriteFigureLabelIsStart.horizontalSpan = 2;
			constraintFWriteFigureLabelIsStart.verticalSpan = 1;
			constraintFWriteFigureLabelIsStart.grabExcessHorizontalSpace = true;
			constraintFWriteFigureLabelIsStart.grabExcessVerticalSpace = true;
			this.add(fWriteFigureLabelIsStart,
					constraintFWriteFigureLabelIsStart);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getWriteFigureLabelId() {
			return fWriteFigureLabelId;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWriteFigureLabelUid() {
			return fWriteFigureLabelUid;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWriteFigureLabelVariable() {
			return fWriteFigureLabelVariable;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWriteFigureLabelIsStart() {
			return fWriteFigureLabelIsStart;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 86, 86, 86);

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 255, 255, 236);

	/**
	 * @generated
	 */
	static final Font WRITEFIGURELABELTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 9, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font WRITEFIGURELABELUIDTITLE0_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FWRITEFIGURELABELUID_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

	/**
	 * @generated
	 */
	static final Font FWRITEFIGURELABELISSTART_FONT = new Font(
			Display.getCurrent(), Display.getDefault().getSystemFont()
					.getFontData()[0].getName(), 8, SWT.ITALIC);

}
