package edu.toronto.cs.se.modelepedia.tso.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.SynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TSOReadWriteSynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TransitionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSODiagramEditorPlugin;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOParserProvider;

/**
 * @generated
 */
public class TSONavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		TSODiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		TSODiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof TSONavigatorItem
				&& !isOwnView(((TSONavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof TSONavigatorGroup) {
			TSONavigatorGroup group = (TSONavigatorGroup) element;
			return TSODiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof TSONavigatorItem) {
			TSONavigatorItem navigatorItem = (TSONavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case FunctionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://edu.toronto.cs.se/modelepedia/tso/1.0?Function", TSOElementTypes.Function_2004); //$NON-NLS-1$
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://edu.toronto.cs.se/modelepedia/tso/1.0?TSOReadWriteSynch", TSOElementTypes.TSOReadWriteSynch_1000); //$NON-NLS-1$
		case SynchEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://edu.toronto.cs.se/modelepedia/tso/1.0?Synch", TSOElementTypes.Synch_4002); //$NON-NLS-1$
		case WriteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://edu.toronto.cs.se/modelepedia/tso/1.0?Write", TSOElementTypes.Write_2001); //$NON-NLS-1$
		case ReadEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://edu.toronto.cs.se/modelepedia/tso/1.0?Read", TSOElementTypes.Read_2002); //$NON-NLS-1$
		case TransitionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://edu.toronto.cs.se/modelepedia/tso/1.0?Transition", TSOElementTypes.Transition_4001); //$NON-NLS-1$
		case CommitEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://edu.toronto.cs.se/modelepedia/tso/1.0?Commit", TSOElementTypes.Commit_2005); //$NON-NLS-1$
		case BarrierEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://edu.toronto.cs.se/modelepedia/tso/1.0?Barrier", TSOElementTypes.Barrier_2003); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = TSODiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& TSOElementTypes.isKnownElementType(elementType)) {
			image = TSOElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof TSONavigatorGroup) {
			TSONavigatorGroup group = (TSONavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof TSONavigatorItem) {
			TSONavigatorItem navigatorItem = (TSONavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case FunctionEditPart.VISUAL_ID:
			return getFunction_2004Text(view);
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return getTSOReadWriteSynch_1000Text(view);
		case SynchEditPart.VISUAL_ID:
			return getSynch_4002Text(view);
		case WriteEditPart.VISUAL_ID:
			return getWrite_2001Text(view);
		case ReadEditPart.VISUAL_ID:
			return getRead_2002Text(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4001Text(view);
		case CommitEditPart.VISUAL_ID:
			return getCommit_2005Text(view);
		case BarrierEditPart.VISUAL_ID:
			return getBarrier_2003Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getFunction_2004Text(View view) {
		IParser parser = TSOParserProvider.getParser(
				TSOElementTypes.Function_2004,
				view.getElement() != null ? view.getElement() : view,
				TSOVisualIDRegistry.getType(FunctionIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5012); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getTSOReadWriteSynch_1000Text(View view) {
		TSOReadWriteSynch domainModelElement = (TSOReadWriteSynch) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getSynch_4002Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getWrite_2001Text(View view) {
		IParser parser = TSOParserProvider.getParser(
				TSOElementTypes.Write_2001,
				view.getElement() != null ? view.getElement() : view,
				TSOVisualIDRegistry.getType(WriteIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRead_2002Text(View view) {
		IParser parser = TSOParserProvider.getParser(TSOElementTypes.Read_2002,
				view.getElement() != null ? view.getElement() : view,
				TSOVisualIDRegistry.getType(ReadIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getTransition_4001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getCommit_2005Text(View view) {
		IParser parser = TSOParserProvider.getParser(
				TSOElementTypes.Commit_2005,
				view.getElement() != null ? view.getElement() : view,
				TSOVisualIDRegistry.getType(CommitIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBarrier_2003Text(View view) {
		IParser parser = TSOParserProvider.getParser(
				TSOElementTypes.Barrier_2003,
				view.getElement() != null ? view.getElement() : view,
				TSOVisualIDRegistry.getType(BarrierIdEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			TSODiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return TSOReadWriteSynchEditPart.MODEL_ID.equals(TSOVisualIDRegistry
				.getModelID(view));
	}

}
