package edu.toronto.cs.se.modelepedia.tso.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import edu.toronto.cs.se.modelepedia.tso.Barrier;
import edu.toronto.cs.se.modelepedia.tso.Commit;
import edu.toronto.cs.se.modelepedia.tso.Function;
import edu.toronto.cs.se.modelepedia.tso.Operation;
import edu.toronto.cs.se.modelepedia.tso.Read;
import edu.toronto.cs.se.modelepedia.tso.Synch;
import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;
import edu.toronto.cs.se.modelepedia.tso.Transition;
import edu.toronto.cs.se.modelepedia.tso.Write;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.SynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TSOReadWriteSynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TransitionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class TSODiagramUpdater {

	/**
	 * @generated
	 */
	public static List<TSONodeDescriptor> getSemanticChildren(View view) {
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return getTSOReadWriteSynch_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSONodeDescriptor> getTSOReadWriteSynch_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		TSOReadWriteSynch modelElement = (TSOReadWriteSynch) view.getElement();
		LinkedList<TSONodeDescriptor> result = new LinkedList<TSONodeDescriptor>();
		for (Iterator<?> it = modelElement.getWrites().iterator(); it.hasNext();) {
			Write childElement = (Write) it.next();
			int visualID = TSOVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == WriteEditPart.VISUAL_ID) {
				result.add(new TSONodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getReads().iterator(); it.hasNext();) {
			Read childElement = (Read) it.next();
			int visualID = TSOVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ReadEditPart.VISUAL_ID) {
				result.add(new TSONodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getBarriers().iterator(); it
				.hasNext();) {
			Barrier childElement = (Barrier) it.next();
			int visualID = TSOVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == BarrierEditPart.VISUAL_ID) {
				result.add(new TSONodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getFunctions().iterator(); it
				.hasNext();) {
			Function childElement = (Function) it.next();
			int visualID = TSOVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FunctionEditPart.VISUAL_ID) {
				result.add(new TSONodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getCommits().iterator(); it
				.hasNext();) {
			Commit childElement = (Commit) it.next();
			int visualID = TSOVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == CommitEditPart.VISUAL_ID) {
				result.add(new TSONodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getContainedLinks(View view) {
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return getTSOReadWriteSynch_1000ContainedLinks(view);
		case WriteEditPart.VISUAL_ID:
			return getWrite_2001ContainedLinks(view);
		case ReadEditPart.VISUAL_ID:
			return getRead_2002ContainedLinks(view);
		case BarrierEditPart.VISUAL_ID:
			return getBarrier_2003ContainedLinks(view);
		case FunctionEditPart.VISUAL_ID:
			return getFunction_2004ContainedLinks(view);
		case CommitEditPart.VISUAL_ID:
			return getCommit_2005ContainedLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4001ContainedLinks(view);
		case SynchEditPart.VISUAL_ID:
			return getSynch_4002ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getIncomingLinks(View view) {
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case WriteEditPart.VISUAL_ID:
			return getWrite_2001IncomingLinks(view);
		case ReadEditPart.VISUAL_ID:
			return getRead_2002IncomingLinks(view);
		case BarrierEditPart.VISUAL_ID:
			return getBarrier_2003IncomingLinks(view);
		case FunctionEditPart.VISUAL_ID:
			return getFunction_2004IncomingLinks(view);
		case CommitEditPart.VISUAL_ID:
			return getCommit_2005IncomingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4001IncomingLinks(view);
		case SynchEditPart.VISUAL_ID:
			return getSynch_4002IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getOutgoingLinks(View view) {
		switch (TSOVisualIDRegistry.getVisualID(view)) {
		case WriteEditPart.VISUAL_ID:
			return getWrite_2001OutgoingLinks(view);
		case ReadEditPart.VISUAL_ID:
			return getRead_2002OutgoingLinks(view);
		case BarrierEditPart.VISUAL_ID:
			return getBarrier_2003OutgoingLinks(view);
		case FunctionEditPart.VISUAL_ID:
			return getFunction_2004OutgoingLinks(view);
		case CommitEditPart.VISUAL_ID:
			return getCommit_2005OutgoingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4001OutgoingLinks(view);
		case SynchEditPart.VISUAL_ID:
			return getSynch_4002OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getTSOReadWriteSynch_1000ContainedLinks(
			View view) {
		TSOReadWriteSynch modelElement = (TSOReadWriteSynch) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_Transition_4001(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_Synch_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getWrite_2001ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getRead_2002ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getBarrier_2003ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getFunction_2004ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getCommit_2005ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getTransition_4001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getSynch_4002ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getWrite_2001IncomingLinks(View view) {
		Write modelElement = (Write) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getRead_2002IncomingLinks(View view) {
		Read modelElement = (Read) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4001(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_Synch_4002(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getBarrier_2003IncomingLinks(View view) {
		Barrier modelElement = (Barrier) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getFunction_2004IncomingLinks(
			View view) {
		Function modelElement = (Function) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getCommit_2005IncomingLinks(View view) {
		Commit modelElement = (Commit) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getTransition_4001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getSynch_4002IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getWrite_2001OutgoingLinks(View view) {
		Write modelElement = (Write) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_Transition_4001(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_Synch_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getRead_2002OutgoingLinks(View view) {
		Read modelElement = (Read) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_Transition_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getBarrier_2003OutgoingLinks(View view) {
		Barrier modelElement = (Barrier) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_Transition_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getFunction_2004OutgoingLinks(
			View view) {
		Function modelElement = (Function) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_Transition_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getCommit_2005OutgoingLinks(View view) {
		Commit modelElement = (Commit) view.getElement();
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_Transition_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getTransition_4001OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<TSOLinkDescriptor> getSynch_4002OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getContainedTypeModelFacetLinks_Transition_4001(
			TSOReadWriteSynch container) {
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		for (Iterator<?> links = container.getTransitions().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Transition) {
				continue;
			}
			Transition link = (Transition) linkObject;
			if (TransitionEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Operation dst = link.getTgt();
			Operation src = link.getSrc();
			result.add(new TSOLinkDescriptor(src, dst, link,
					TSOElementTypes.Transition_4001,
					TransitionEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getContainedTypeModelFacetLinks_Synch_4002(
			TSOReadWriteSynch container) {
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		for (Iterator<?> links = container.getSynchronizations().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Synch) {
				continue;
			}
			Synch link = (Synch) linkObject;
			if (SynchEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Read dst = link.getTgt();
			Write src = link.getSrc();
			result.add(new TSOLinkDescriptor(src, dst, link,
					TSOElementTypes.Synch_4002, SynchEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getIncomingTypeModelFacetLinks_Transition_4001(
			Operation target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != TSOPackage.eINSTANCE
					.getTransition_Tgt()
					|| false == setting.getEObject() instanceof Transition) {
				continue;
			}
			Transition link = (Transition) setting.getEObject();
			if (TransitionEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Operation src = link.getSrc();
			result.add(new TSOLinkDescriptor(src, target, link,
					TSOElementTypes.Transition_4001,
					TransitionEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getIncomingTypeModelFacetLinks_Synch_4002(
			Read target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != TSOPackage.eINSTANCE
					.getSynch_Tgt()
					|| false == setting.getEObject() instanceof Synch) {
				continue;
			}
			Synch link = (Synch) setting.getEObject();
			if (SynchEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Write src = link.getSrc();
			result.add(new TSOLinkDescriptor(src, target, link,
					TSOElementTypes.Synch_4002, SynchEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getOutgoingTypeModelFacetLinks_Transition_4001(
			Operation source) {
		TSOReadWriteSynch container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof TSOReadWriteSynch) {
				container = (TSOReadWriteSynch) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		for (Iterator<?> links = container.getTransitions().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Transition) {
				continue;
			}
			Transition link = (Transition) linkObject;
			if (TransitionEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Operation dst = link.getTgt();
			Operation src = link.getSrc();
			if (src != source) {
				continue;
			}
			result.add(new TSOLinkDescriptor(src, dst, link,
					TSOElementTypes.Transition_4001,
					TransitionEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<TSOLinkDescriptor> getOutgoingTypeModelFacetLinks_Synch_4002(
			Write source) {
		TSOReadWriteSynch container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof TSOReadWriteSynch) {
				container = (TSOReadWriteSynch) element;
			}
		}
		if (container == null) {
			return Collections.emptyList();
		}
		LinkedList<TSOLinkDescriptor> result = new LinkedList<TSOLinkDescriptor>();
		for (Iterator<?> links = container.getSynchronizations().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Synch) {
				continue;
			}
			Synch link = (Synch) linkObject;
			if (SynchEditPart.VISUAL_ID != TSOVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Read dst = link.getTgt();
			Write src = link.getSrc();
			if (src != source) {
				continue;
			}
			result.add(new TSOLinkDescriptor(src, dst, link,
					TSOElementTypes.Synch_4002, SynchEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<TSONodeDescriptor> getSemanticChildren(View view) {
			return TSODiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<TSOLinkDescriptor> getContainedLinks(View view) {
			return TSODiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<TSOLinkDescriptor> getIncomingLinks(View view) {
			return TSODiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<TSOLinkDescriptor> getOutgoingLinks(View view) {
			return TSODiagramUpdater.getOutgoingLinks(view);
		}
	};

}
