package edu.toronto.cs.se.modelepedia.tso.diagram.part;

import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import edu.toronto.cs.se.modelepedia.tso.diagram.providers.TSOElementTypes;

/**
 * @generated
 */
public class TSOPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createOperations1Group());
		paletteRoot.add(createRelations2Group());
	}

	/**
	 * Creates "Operations" palette tool group
	 * @generated
	 */
	private PaletteContainer createOperations1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Operations1Group_title);
		paletteContainer.setId("createOperations1Group"); //$NON-NLS-1$
		paletteContainer.add(createRead1CreationTool());
		paletteContainer.add(createWrite2CreationTool());
		paletteContainer.add(createMemoryBarrier3CreationTool());
		paletteContainer.add(createFunction4CreationTool());
		paletteContainer.add(createCommit5CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Relations" palette tool group
	 * @generated
	 */
	private PaletteContainer createRelations2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Relations2Group_title);
		paletteContainer.setId("createRelations2Group"); //$NON-NLS-1$
		paletteContainer.add(createTransition1CreationTool());
		paletteContainer.add(createSynchronization2CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRead1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Read1CreationTool_title,
				Messages.Read1CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Read_2002));
		entry.setId("createRead1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Read_2002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createWrite2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Write2CreationTool_title,
				Messages.Write2CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Write_2001));
		entry.setId("createWrite2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Write_2001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMemoryBarrier3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.MemoryBarrier3CreationTool_title,
				Messages.MemoryBarrier3CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Barrier_2003));
		entry.setId("createMemoryBarrier3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Barrier_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createFunction4CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Function4CreationTool_title,
				Messages.Function4CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Function_2004));
		entry.setId("createFunction4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Function_2004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCommit5CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Commit5CreationTool_title,
				Messages.Commit5CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Commit_2005));
		entry.setId("createCommit5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Commit_2005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTransition1CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Transition1CreationTool_title,
				Messages.Transition1CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Transition_4001));
		entry.setId("createTransition1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Transition_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createSynchronization2CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.Synchronization2CreationTool_title,
				Messages.Synchronization2CreationTool_desc,
				Collections.singletonList(TSOElementTypes.Synch_4002));
		entry.setId("createSynchronization2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(TSOElementTypes
				.getImageDescriptor(TSOElementTypes.Synch_4002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
