package edu.toronto.cs.se.modelepedia.tso.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitVariableEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitWIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionNameEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadVariableEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.SynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TSOReadWriteSynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TransitionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteIdEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteIsStartEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteUidEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteVariableEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class TSOVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "TSO30.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (TSOReadWriteSynchEditPart.MODEL_ID.equals(view.getType())) {
				return TSOReadWriteSynchEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				TSODiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (TSOPackage.eINSTANCE.getTSOReadWriteSynch().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((TSOReadWriteSynch) domainElement)) {
			return TSOReadWriteSynchEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
				.getModelID(containerView);
		if (!TSOReadWriteSynchEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (TSOReadWriteSynchEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = TSOReadWriteSynchEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			if (TSOPackage.eINSTANCE.getWrite().isSuperTypeOf(
					domainElement.eClass())) {
				return WriteEditPart.VISUAL_ID;
			}
			if (TSOPackage.eINSTANCE.getRead().isSuperTypeOf(
					domainElement.eClass())) {
				return ReadEditPart.VISUAL_ID;
			}
			if (TSOPackage.eINSTANCE.getBarrier().isSuperTypeOf(
					domainElement.eClass())) {
				return BarrierEditPart.VISUAL_ID;
			}
			if (TSOPackage.eINSTANCE.getFunction().isSuperTypeOf(
					domainElement.eClass())) {
				return FunctionEditPart.VISUAL_ID;
			}
			if (TSOPackage.eINSTANCE.getCommit().isSuperTypeOf(
					domainElement.eClass())) {
				return CommitEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
				.getModelID(containerView);
		if (!TSOReadWriteSynchEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (TSOReadWriteSynchEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = TSOReadWriteSynchEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			if (WriteEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ReadEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BarrierEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FunctionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommitEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case WriteEditPart.VISUAL_ID:
			if (WriteIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WriteUidEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WriteVariableEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (WriteIsStartEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ReadEditPart.VISUAL_ID:
			if (ReadIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ReadUidEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ReadVariableEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ReadIsStartEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case BarrierEditPart.VISUAL_ID:
			if (BarrierIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BarrierUidEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BarrierIsStartEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FunctionEditPart.VISUAL_ID:
			if (FunctionIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FunctionUidEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FunctionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FunctionIsStartEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CommitEditPart.VISUAL_ID:
			if (CommitIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommitUidEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommitVariableEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommitWIdEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (TSOPackage.eINSTANCE.getTransition().isSuperTypeOf(
				domainElement.eClass())) {
			return TransitionEditPart.VISUAL_ID;
		}
		if (TSOPackage.eINSTANCE.getSynch().isSuperTypeOf(
				domainElement.eClass())) {
			return SynchEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(TSOReadWriteSynch element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return false;
		case WriteEditPart.VISUAL_ID:
		case ReadEditPart.VISUAL_ID:
		case BarrierEditPart.VISUAL_ID:
		case FunctionEditPart.VISUAL_ID:
		case CommitEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return edu.toronto.cs.se.modelepedia.tso.diagram.part.TSOVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
