package edu.toronto.cs.se.modelepedia.tso.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.BarrierEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.CommitEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.FunctionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.ReadEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.SynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TSOReadWriteSynchEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.TransitionEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.edit.parts.WriteEditPart;
import edu.toronto.cs.se.modelepedia.tso.diagram.part.TSODiagramEditorPlugin;

/**
 * @generated
 */
public class TSOElementTypes {

	/**
	 * @generated
	 */
	private TSOElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType TSOReadWriteSynch_1000 = getElementType("TSO30.diagram.TSOReadWriteSynch_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Write_2001 = getElementType("TSO30.diagram.Write_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Read_2002 = getElementType("TSO30.diagram.Read_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Barrier_2003 = getElementType("TSO30.diagram.Barrier_2003"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Function_2004 = getElementType("TSO30.diagram.Function_2004"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Commit_2005 = getElementType("TSO30.diagram.Commit_2005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Transition_4001 = getElementType("TSO30.diagram.Transition_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Synch_4002 = getElementType("TSO30.diagram.Synch_4002"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return TSODiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(TSOReadWriteSynch_1000,
					TSOPackage.eINSTANCE.getTSOReadWriteSynch());

			elements.put(Write_2001, TSOPackage.eINSTANCE.getWrite());

			elements.put(Read_2002, TSOPackage.eINSTANCE.getRead());

			elements.put(Barrier_2003, TSOPackage.eINSTANCE.getBarrier());

			elements.put(Function_2004, TSOPackage.eINSTANCE.getFunction());

			elements.put(Commit_2005, TSOPackage.eINSTANCE.getCommit());

			elements.put(Transition_4001, TSOPackage.eINSTANCE.getTransition());

			elements.put(Synch_4002, TSOPackage.eINSTANCE.getSynch());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(TSOReadWriteSynch_1000);
			KNOWN_ELEMENT_TYPES.add(Write_2001);
			KNOWN_ELEMENT_TYPES.add(Read_2002);
			KNOWN_ELEMENT_TYPES.add(Barrier_2003);
			KNOWN_ELEMENT_TYPES.add(Function_2004);
			KNOWN_ELEMENT_TYPES.add(Commit_2005);
			KNOWN_ELEMENT_TYPES.add(Transition_4001);
			KNOWN_ELEMENT_TYPES.add(Synch_4002);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case TSOReadWriteSynchEditPart.VISUAL_ID:
			return TSOReadWriteSynch_1000;
		case WriteEditPart.VISUAL_ID:
			return Write_2001;
		case ReadEditPart.VISUAL_ID:
			return Read_2002;
		case BarrierEditPart.VISUAL_ID:
			return Barrier_2003;
		case FunctionEditPart.VISUAL_ID:
			return Function_2004;
		case CommitEditPart.VISUAL_ID:
			return Commit_2005;
		case TransitionEditPart.VISUAL_ID:
			return Transition_4001;
		case SynchEditPart.VISUAL_ID:
			return Synch_4002;
		}
		return null;
	}

}
