/**
 */
package edu.toronto.cs.se.modelepedia.tso.provider;


import edu.toronto.cs.se.modelepedia.tso.TSOFactory;
import edu.toronto.cs.se.modelepedia.tso.TSOPackage;
import edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.toronto.cs.se.modelepedia.tso.TSOReadWriteSynch} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TSOReadWriteSynchItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TSOReadWriteSynchItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_TSOReadWriteSynch_name_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_TSOReadWriteSynch_name_feature", "_UI_TSOReadWriteSynch_type"),
				 TSOPackage.Literals.TSO_READ_WRITE_SYNCH__NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__READS);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__WRITES);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__COMMITS);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__FUNCTIONS);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__BARRIERS);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__TRANSITIONS);
			childrenFeatures.add(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns TSOReadWriteSynch.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/TSOReadWriteSynch"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((TSOReadWriteSynch)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_TSOReadWriteSynch_type") :
			getString("_UI_TSOReadWriteSynch_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(TSOReadWriteSynch.class)) {
			case TSOPackage.TSO_READ_WRITE_SYNCH__NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case TSOPackage.TSO_READ_WRITE_SYNCH__READS:
			case TSOPackage.TSO_READ_WRITE_SYNCH__WRITES:
			case TSOPackage.TSO_READ_WRITE_SYNCH__COMMITS:
			case TSOPackage.TSO_READ_WRITE_SYNCH__FUNCTIONS:
			case TSOPackage.TSO_READ_WRITE_SYNCH__BARRIERS:
			case TSOPackage.TSO_READ_WRITE_SYNCH__TRANSITIONS:
			case TSOPackage.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__READS,
				 TSOFactory.eINSTANCE.createRead()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__WRITES,
				 TSOFactory.eINSTANCE.createWrite()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__COMMITS,
				 TSOFactory.eINSTANCE.createCommit()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__FUNCTIONS,
				 TSOFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__BARRIERS,
				 TSOFactory.eINSTANCE.createBarrier()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__TRANSITIONS,
				 TSOFactory.eINSTANCE.createTransition()));

		newChildDescriptors.add
			(createChildParameter
				(TSOPackage.Literals.TSO_READ_WRITE_SYNCH__SYNCHRONIZATIONS,
				 TSOFactory.eINSTANCE.createSynch()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return TSOEditPlugin.INSTANCE;
	}

}
