package edu.toronto.cs.christoff.tsoui;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.Font;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.BoxLayout;
import java.awt.Component;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.RowSpec;
import javax.swing.UIManager;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.SystemColor;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.BevelBorder;
import javax.swing.JSeparator;
import javax.swing.JTextArea;

// $hide>>$
import edu.toronto.cs.christoff.tsorws.*;
// $hide<<$

public class TSORWSMainWin {
	
	// $hide>>$
	private TSORWSTransform transform;
	private TSORWSSerializeDeserialize tsoreaderwriter;
	private String infile = "";
	private String outfile = "";
	private String modelsPath = "C:\\Users\\mikle\\Documents\\MSc\\CSC 2125\\Project\\runtime-EclipseApplication\\TestDiag30\\model";
	// $hide<<$
	
	// $hide>>$
	private void tsoInit()
	{
		tsoreaderwriter = new TSORWSSerializeDeserialize();
		transform = new TSORWSTransform();
	}
	// $hide<<$
	
	// $hide>>$
	private boolean badFiles()
	{
		if(isBlank(infile) || isBlank(outfile) || isBlank(modelsPath))
		{
			System.out.println("Input, output, or model file names/path have not been properly set");
			return true;
		}
		return false;
	}
	// $hide<<$
	
	// $hide>>$
	private boolean isBlank(String s)
	{
		if(s == null)
			return true;
		return s.equals("");
	}
	// $hide<<$	

	private JFrame frmTsoHelper;
	private JTextField txtInputFile;
	private JTextField txtOutputFile;
	private JTextField txtModelsPath;
	private JTextField txtTreeIterations;
	private JTextField txtTransformIterations;
	private JTextField txtTransformCommitFilter;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {	
		
		// $hide>>$
		try {
			  UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch(Exception e) {
			  System.out.println("Error setting native LAF: " + e);
		}
		// $hide<<$
		
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					TSORWSMainWin window = new TSORWSMainWin();
					window.frmTsoHelper.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public TSORWSMainWin() {
		initialize();
		
		// $hide>>$
		tsoInit();
		// $hide<<$
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmTsoHelper = new JFrame();
		frmTsoHelper.setTitle("TSO Helper");
		frmTsoHelper.setBounds(100, 100, 483, 458);
		frmTsoHelper.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		JPanel panel = new JPanel();
		panel.setBackground(Color.WHITE);
		panel.setBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null));
		frmTsoHelper.getContentPane().add(panel, BorderLayout.NORTH);
		panel.setLayout(new GridLayout(2, 1, 0, 0));
		
		JLabel lblNewLabel = new JLabel("  TSO Helper");
		lblNewLabel.setFont(new Font("Tahoma", Font.PLAIN, 18));
		panel.add(lblNewLabel);
		
		JLabel lblNewLabel_1 = new JLabel("            Access all TSO Helper tools from this control panel");
		lblNewLabel_1.setFont(new Font("Tahoma", Font.PLAIN, 11));
		panel.add(lblNewLabel_1);
		
		JPanel panel_1 = new JPanel();
		frmTsoHelper.getContentPane().add(panel_1, BorderLayout.CENTER);
		panel_1.setLayout(new GridLayout(2, 1, 0, 0));
		
		JPanel panel_2 = new JPanel();
		panel_2.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Enter settings", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.add(panel_2);
		panel_2.setLayout(null);
		
		JLabel lblInputFile = new JLabel("Input file");
		lblInputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblInputFile.setBounds(10, 31, 46, 14);
		panel_2.add(lblInputFile);
		
		txtInputFile = new JTextField();
		txtInputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtInputFile.setBounds(95, 28, 240, 20);
		panel_2.add(txtInputFile);
		txtInputFile.setColumns(10);
		
		JButton btnInputFile = new JButton("Set");
		btnInputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// SET INPUT FILE
				
				infile = txtInputFile.getText();
				System.out.println("Input file set to " + infile);
			}
		});
		btnInputFile.setBackground(UIManager.getColor("Button.background"));
		btnInputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnInputFile.setBounds(347, 27, 89, 23);
		panel_2.add(btnInputFile);
		
		JLabel lblOutputFile = new JLabel("Output file");
		lblOutputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblOutputFile.setBounds(10, 64, 63, 14);
		panel_2.add(lblOutputFile);
		
		txtOutputFile = new JTextField();
		txtOutputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtOutputFile.setBounds(95, 61, 240, 20);
		panel_2.add(txtOutputFile);
		txtOutputFile.setColumns(10);
		
		JButton btnOutputFile = new JButton("Set");
		btnOutputFile.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// SET OUTPUT FILE
				
				outfile = txtOutputFile.getText();
				System.out.println("Output file set to " + outfile);				
			}
		});
		btnOutputFile.setBackground(UIManager.getColor("Button.background"));
		btnOutputFile.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnOutputFile.setBounds(347, 60, 89, 23);
		panel_2.add(btnOutputFile);
		
		JLabel lblModelsPath = new JLabel("Models path");
		lblModelsPath.setFont(new Font("Tahoma", Font.PLAIN, 11));
		lblModelsPath.setBounds(10, 105, 75, 14);
		panel_2.add(lblModelsPath);
		
		txtModelsPath = new JTextField();
		txtModelsPath.setText("C:\\Users\\mikle\\Documents\\MSc\\CSC 2125\\Project\\runtime-EclipseApplication\\TestDiag30\\model");
		txtModelsPath.setFont(new Font("Tahoma", Font.PLAIN, 11));
		txtModelsPath.setBounds(95, 101, 240, 20);
		panel_2.add(txtModelsPath);
		txtModelsPath.setColumns(10);
		
		JButton btnModelsPath = new JButton("Set");
		btnModelsPath.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// SET MODELS PATH
				
				modelsPath = txtModelsPath.getText();
				System.out.println("Models path set to " + modelsPath);					
			}
		});
		btnModelsPath.setFont(new Font("Tahoma", Font.PLAIN, 11));
		btnModelsPath.setBounds(347, 98, 89, 23);
		panel_2.add(btnModelsPath);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Tools", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.add(panel_3);
		panel_3.setLayout(new GridLayout(0, 1, 0, 0));
		
		JPanel panel_4 = new JPanel();
		panel_4.setBorder(new LineBorder(SystemColor.activeCaption));
		panel_4.setBackground(SystemColor.inactiveCaptionBorder);
		panel_3.add(panel_4);
		panel_4.setLayout(null);
		
		JButton btnRunReplaceFunctions = new JButton("Run");
		btnRunReplaceFunctions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// REPLACE FUNCTION NODES
				if(badFiles()) return;
				
				ReadWriteSynch tso = null;
				try {
					
					tso = tsoreaderwriter.deserialize(modelsPath, infile);
					transform.expandFunctions(tso);
					tsoreaderwriter.serialize(tso, modelsPath, outfile);
					
				} catch(Exception ex) {
					System.out.println(ex.getMessage());
					return;
				}
			}
		});
		btnRunReplaceFunctions.setBounds(12, 13, 89, 23);
		panel_4.add(btnRunReplaceFunctions);
		
		JLabel lblReplaceFunctions = new JLabel("Replace Function nodes with Read/Write nodes");
		lblReplaceFunctions.setBounds(113, 18, 330, 14);
		panel_4.add(lblReplaceFunctions);
		
		JSeparator separator = new JSeparator();
		separator.setBounds(12, 122, 431, 2);
		panel_4.add(separator);
		
		JButton btnTest = new JButton("Test");
		btnTest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// TEST SERIALIZER/DESERIALIZER
				if(badFiles()) return;
				
				ReadWriteSynch tso = null;
				try {
					
					tso = tsoreaderwriter.deserialize(modelsPath, infile);
					tsoreaderwriter.serialize(tso, modelsPath, outfile);
					
				} catch(Exception ex) {
					System.out.println(ex.getMessage());
					ex.printStackTrace();
					return;
				}				
				
			}
		});
		btnTest.setBounds(10, 129, 89, 23);
		panel_4.add(btnTest);
		
		JLabel lblTest = new JLabel("Test serializer/deserializer");
		lblTest.setBounds(113, 133, 226, 14);
		panel_4.add(lblTest);
		
		JButton btnRunTree = new JButton("Run");
		btnRunTree.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// BUILD TREE
				if(badFiles()) return;
				
				String iterations = txtTreeIterations.getText();
				int iters;
				try {
					iters = Integer.valueOf(iterations);
				} catch(Exception ex) {
					System.out.println("Not a number");
					txtTreeIterations.setText("1");
					return;
				}
				
				if(iters > 3 || iters < 1)
				{
					txtTreeIterations.setText("1");
					return;
				}				
				
				ReadWriteSynch tso = null;
				try {
					
					tso = tsoreaderwriter.deserialize(modelsPath, infile);
					ReadWriteSynch tree = transform.buildTree(tso, iters);
					tsoreaderwriter.serialize(tree, modelsPath, outfile);
					
				} catch(Exception ex) {
					System.out.println(ex.getMessage());
					ex.printStackTrace();
					return;
				}									
			}
		});
		btnRunTree.setBounds(12, 47, 89, 23);
		panel_4.add(btnRunTree);
		
		JLabel lblTreeLeft = new JLabel("Expand graph into Tree representing");
		lblTreeLeft.setBounds(113, 51, 182, 14);
		panel_4.add(lblTreeLeft);
		
		txtTreeIterations = new JTextField();
		txtTreeIterations.setText("1");
		txtTreeIterations.setBounds(294, 48, 20, 20);
		panel_4.add(txtTreeIterations);
		txtTreeIterations.setColumns(10);
		
		JLabel lblTreeRight = new JLabel("iteration(s).");
		lblTreeRight.setBounds(318, 51, 68, 14);
		panel_4.add(lblTreeRight);
		
		JButton btnRunTransform = new JButton("Run");
		btnRunTransform.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// FULL TRANSFORM
				if(badFiles()) return;
				
				String iterations = txtTransformIterations.getText();
				int iters;
				try {
					iters = Integer.valueOf(iterations);
				} catch(Exception ex) {
					System.out.println("Not a number");
					txtTransformIterations.setText("" + transform.getIterations());
					return;
				}
				
				String commitFilter = txtTransformCommitFilter.getText();
				int commits;
				try {
					commits = Integer.valueOf(commitFilter);
				} catch(Exception ex) {
					System.out.println("Not a number");
					txtTransformCommitFilter.setText("" + transform.getCommitFilter());
					return;
				}				
				
				transform.setIterations(iters);				
				if(iters != transform.getIterations())
				{
					txtTransformIterations.setText("" + transform.getIterations());
					return;
				}			
				
				transform.setCommitFilter(commits);				
				if(commits != transform.getCommitFilter())
				{
					txtTransformCommitFilter.setText("" + transform.getCommitFilter());
					return;
				}				
				
				ReadWriteSynch tso = null;
				try {
					
					tso = tsoreaderwriter.deserialize(modelsPath, infile);
					ReadWriteSynch tree = transform.transform(tso, iters);
					tsoreaderwriter.serialize(tree, modelsPath, outfile);
					
				} catch(Exception ex) {
					System.out.println(ex.getMessage());
					ex.printStackTrace();
					return;
				}					
			}
		});
		btnRunTransform.setBounds(12, 81, 89, 23);
		panel_4.add(btnRunTransform);
		
		JLabel lblTransformLeft = new JLabel("Transform graph using");
		lblTransformLeft.setBounds(113, 87, 114, 14);
		panel_4.add(lblTransformLeft);
		
		txtTransformIterations = new JTextField();
		txtTransformIterations.setText("1");
		txtTransformIterations.setColumns(10);
		txtTransformIterations.setBounds(223, 84, 20, 20);
		panel_4.add(txtTransformIterations);
		
		JLabel lblTransformRight = new JLabel("iteration(s) and a commit filter of ");
		lblTransformRight.setBounds(247, 87, 165, 14);
		panel_4.add(lblTransformRight);
		
		txtTransformCommitFilter = new JTextField();
		txtTransformCommitFilter.setText("1");
		txtTransformCommitFilter.setBounds(411, 82, 20, 20);
		panel_4.add(txtTransformCommitFilter);
		txtTransformCommitFilter.setColumns(10);
	}
}
